//
// pۍ쐬
//
// written by T.Noda
//
// 2001/06/28 Ver 0.0.1 pۓWJ
// 2001/06/29 Ver 0.0.2 R[i[qɑΉ
// FΐSpۂ̗\
//
// D:a H: A, B:̕ CR:R[i[q CL:؂荞ݒ
//
//
//************************************
//
//  f[^ւ
//
//************************************
procedure SwapValue(var SA : double; var EA : double);
var
  temp : double;
begin
  temp := SA;
  SA := EA;
  EA := temp;
end;
//************************************
//
//  a擾
//
//************************************
function RadiusGet(px1 : double; py1 : double; px2 : double; py2 : double; px3 : double; py3 : double) : double;
var
  L1, L2, L3 : double;
begin
  L1 := Distance(px1, py1, px2, py2);
  L2 := Distance(px2, py2, px3, py3);
  L3 := Distance(px3, py3, px1, py1);
  Result := 0.5*L2/(sin(ArcCos((L1*L1+L3*L3-L2*L2)/(2.0*L1*L3))));
end;
//************************************
//
//  SW擾
//
//************************************
procedure CenterPointGet(var x0 : double; var y0 : double; x1 : double; y1 : double; x2 : double; y2 : double; x3 : double; y3 : double);
var
  a1, a2, b1, b2, xm1, ym1, xm2, ym2, ang1, ang2 : double;
  flg1, flg2 : boolean;
begin
  xm1 := 0.5*(x1+x2);  // _擾
  ym1 := 0.5*(y1+y2);
  xm2 := 0.5*(x2+x3);
  ym2 := 0.5*(y2+y3);
  ang1 := PosToAngl(x1, y1, x2, y2)+90.0;
  if ang1 > 360.0 then
  begin
    ang1 := ang1-360.0;
  end;
  ang2 := PosToAngl(x2, y2, x3, y3)+90.0;
  if ang2 > 360.0 then
  begin
    ang2 := ang2-360.0;
  end;
  if (ang1=90.0)OR(ang1=270.0) then
  begin
    x0 := xm1;
    flg1 := true;
  end
  else
  begin
    a1 := tan(ang1);
    b1 := ym1-a1*xm1;
    flg1 := false;
  end;
  if (ang2=90.0)OR(ang2=270.0) then
  begin
    x0 := xm2;
    flg2 := true;
  end
  else
  begin
    a2 := tan(ang2);
    b2 := ym2-a2*xm2;
    flg2 := false;
  end;
  if flg1 = true then
  begin
    y0 := a2*x0+b2;
  end
  else if flg2 = true then
  begin
    y0 := a1*x0+b1;
  end
  else
  begin
    x0 := -(b2-b1)/(a2-a1);
    y0 := -(a1*b2-a2*b1)/(a2-a1);
  end;
end;
//************************************
//
//  ~ʕԕ`
//
//************************************
procedure PrintArc(x1 : double; y1 : double; x2 : double; y2 : double; x3 : double; y3 : double; xm : double);
var
  x0, y0, r, SA, EA : double;
begin
  r := RadiusGet(x1, y1, x2, y2, x3, y3);
  CenterPointGet(x0, y0, x1, y1, x2, y2, x3, y3);
  SA := PosToAngl(x0, y0, x1, y1);
  EA := PosToAngl(x0, y0, x3, y3);
  if EA - SA > 180.0 then
    begin
      SwapValue(SA, EA);
    end;
  if EA < SA then
    begin
      SwapValue(SA, EA);
    end;
  Arc(x0, y0, r, SA, EA);
  x0 := 2.0*xm-x0;
  SA := 540.0-SA;
  EA := 540.0-EA;
  Arc(x0, y0, r, EA, SA);
end;
//************************************
//
//  CvO
//
//************************************
Program RECT2CIRCLE;
var
  x, y : Array of double;
  D, H, A, B, C, CC, CL, CR, L, M, N, H1, H2, ang : double;
  i, j, k : integer;

Begin
  AddImage(20, 20, 'RECT2CIRCLE_PARAM.BMP');
  AddLabel(130, 20, 95, 13, 'a(D)');
  AddLabel(130, 50, 95, 13, '(H)');
  AddLabel(130, 80, 95, 13, '̕(A)');
  AddLabel(130, 110, 95, 13, '̕(B)');
  AddLabel(130, 140, 95, 13, 'R[i[q(R)');
  AddLabel(130, 170, 95, 13, '؍(L)');
  AddEdit(1, 230, 20, 50, 21, '');
  AddEdit(2, 230, 50, 50, 21, '');
  AddEdit(3, 230, 80, 50, 21, '');
  AddEdit(4, 230, 110, 50, 21, '');
  AddEdit(5, 230, 140, 50, 21, '');
  AddEdit(6, 230, 170, 50, 21, '');
  AddCheckBox(1, 20, 180, true, '⏕}'); // `FbN{bNX
  If ShowDlg(300, 250,'pۍ}_CAO') <> True Then
    Exit;
  D := StrToFloat(GetDlgText(1)); // ɕϊ
  H := StrToFloat(GetDlgText(2));
  A := StrToFloat(GetDlgText(3));
  B := StrToFloat(GetDlgText(4));
  CR := StrToFloat(GetDlgText(5));
  CL := StrToFloat(GetDlgText(6));

  if (D-0.001 < 0.0) OR (H-0.001 < 0.0) OR (A-0.001 < 0.0) OR (B-0.001 < 0.0) then
  begin
    OkMsgBox('̓f[^Ɍ肪܂B');
    exit;
  end;
  SetArrayLength(x, 13);
  SetArrayLength(y, 13);
  C := D*Pi/24.0;
  CC := CR*Pi/12.0;
  H1 := Sqrt(H*H+0.25*(B-D)*(B-D));
  H2 := Sqrt(H*H+0.25*(A-D)*(A-D));
  A := A-2.0*CR;
  B := B-2.0*CR;
  if (A < 0.0) OR (B < 0.0) then
  begin
    OkMsgBox('R[i[q傫܂B');
    exit;
  end;
  Message('zuʒu͂ĉB');
  if GetPos(x[10], y[10]) = false then
  begin
    exit.
  end;
  x[0] := x[10];
  y[0] := y[10];
  LineType(0);  // 
  PenNo(1);     // yԍ
  x[1] := x[0]+0.5*A;
  y[1] := y[0];
  x[2] := x[0]-0.5*A;
  y[2] := y[0];
  Line(x[1], y[1], x[2], y[2]);
  if CheckBoxChecked(1) then
  begin
    LineType(2);
    Line(x[2], y[2], x[0], y[0]+H1);
    Line(x[0], y[0]+H1, x[0]+0.5*A, y[0]);
    LineType(0);
  end;
  x[4] := x[0];
  y[4] := y[0]+H1;
  x[9] := x[0]+0.5*A;
  y[9] := y[0];
  x[1] := x[4];
  y[1] := y[4];
  x[6] := x[9];
  y[6] := y[9];
  for i:=1 to 6 do
  begin
    x[11] := 0.5*A+CR*cos(90.0-i*15.0)-0.5*D*cos(90.0-i*15.0);
    y[11] := 0.5*B+CR*sin(90.0+i*15.0)-0.5*D*sin(90.0-i*15.0);
    L := Sqrt(x[11]*x[11]+y[11]*y[11]+H*H);
    x[12] := 0.5*A+CR*cos(90.0-(i-1)*15.0)-0.5*D*cos(90.0-i*15.0);
    y[12] := 0.5*B+CR*sin(90.0+(i-1)*15.0)-0.5*D*sin(90.0-i*15.0);
    M := Sqrt(x[12]*x[12]+y[12]*y[12]+H*H);
    N := Distance(x[9], y[9], x[4], y[4]);
    x[11] := x[9]-M*cos(ArcCos((M*M+N*N-C*C)/(2.0*M*N))+180.0-PosToAngl(x[9], y[9], x[4], y[4]));
    y[11] := y[9]+M*sin(ArcCos((M*M+N*N-C*C)/(2.0*M*N))+180.0-PosToAngl(x[9], y[9], x[4], y[4]));
    x[4] := x[11];
    y[4] := y[11];
    if CR <> 0.0 then
    begin
      x[12] := x[4]+L*cos(ArcCos((L*L+M*M-CC*CC)/(2.0*L*M))+PosToAngl(x[4], y[4], x[9], y[9]));
      y[12] := y[4]+L*sin(ArcCos((L*L+M*M-CC*CC)/(2.0*L*M))+PosToAngl(x[4], y[4], x[9], y[9]));
    end
    else
    begin
      x[12] := x[9];
      y[12] := y[9];
    end;
    x[9] := x[12];
    y[9] := y[12];
    if i = 3 then   // ؂荞ݐ`
    begin
      ang := PosToAngl(x[9], y[9], x[4], y[4]);
      Line(x[9]-5.0*cos(ang), y[9]-5.0*sin(ang), x[9]+CL*cos(ang), y[9]+CL*sin(ang));
      ang := PosToAngl(2.0*x[10]-x[9], y[9], 2.0*x[10]-x[4], y[4]);
      Line(2.0*x[10]-x[9]-5.0*cos(ang), y[9]-5.0*sin(ang), 2.0*x[10]-x[9]+CL*cos(ang), y[9]+CL*sin(ang));
    end;
    if CheckBoxChecked(1) then  // ⏕`
    begin
      LineType(2);  // 
      Line(x[9], y[9], x[4], y[4]);
      Line(2.0*x[10]-x[9], y[9], 2.0*x[10]-x[4], y[4]);
      LineType(0);  // 
    end;
    if (i mod 2) = 1 then
    begin
      x[2] := x[11];
      y[2] := y[11];
      x[7] := x[12];
      y[7] := y[12];
    end
    else
    begin
      x[3] := x[11];
      y[3] := y[11];
      x[8] := x[12];
      y[8] := y[12];
      PrintArc(x[1], y[1], x[2], y[2], x[3], y[3], x[10]);
      if CR <> 0 then
      begin
        PrintArc(x[6], y[6], x[7], y[7], x[8], y[8], x[10]);
      end;
      x[1] := x[3];
      y[1] := y[3];
      x[6] := x[8];
      y[6] := y[8];
    end;
  end;
  if B > 0.0 then
  begin
    x[11] := x[9]-0.5*B*cos(ArcCos((L*L+0.25*B*B-H2*H2)/(L*B))+180.0-PosToAngl(x[9], y[9], x[4], y[4]));
    y[11] := y[9]+0.5*B*sin(ArcCos((L*L+0.25*B*B-H2*H2)/(L*B))+180.0-PosToAngl(x[9], y[9], x[4], y[4]));
    Line(x[11], y[11], x[9], y[9]);
    Line(2.0*x[10]-x[11], y[11], 2.0*x[10]-x[9], y[9]);
  end
  else
  begin
    x[11] := x[9];
    y[11] := y[9];
  end;
  Line(x[4], y[4], x[11], y[11]);
  Line(2.0*x[10]-x[4], y[4], 2.0*x[10]-x[11], y[11]);
End.
